//
//  Category.m
//  Compare Prices
//
//  Created by Jesper Forsberg on 2011-08-14.
//  Copyright 2011 Jesper Forsberg. All rights reserved.
//

#import "Category.h"

@implementation Category

@synthesize id, parentId, name, hitCount, score, parentName, isLeaf;

- (id)init
{
    self = [super init];
    if (self) {
        // Initialization code here.
        score = 0.0f;
        hitCount = 0;
    }
    
    return self;
}

- (void)encodeWithCoder:(NSCoder *)coder {
    [coder encodeInteger:self.id forKey:@"CategoryId"];
    [coder encodeInteger:parentId forKey:@"CategoryParentId"];
    [coder encodeObject:name forKey:@"CategoryName"];
    [coder encodeInteger:hitCount forKey:@"CategoryHitCount"];
    [coder encodeFloat:score forKey:@"CategoryScore"];
    [coder encodeObject:parentName forKey:@"CategoryParentName"];
    [coder encodeBool:isLeaf forKey:@"CategoryIsLeaf"];
}

- (id)initWithCoder:(NSCoder *)coder
{
    if (self = [super init]) {
        self.id = [coder decodeIntegerForKey:@"CategoryId"];
        self.parentId = [coder decodeIntegerForKey:@"CategoryParentId"];
        self.name = [coder decodeObjectForKey:@"CategoryName"];
        self.hitCount = [coder decodeIntegerForKey:@"CategoryHitCount"];
        self.score = [coder decodeFloatForKey:@"CategoryScore"];
        self.parentName = [coder decodeObjectForKey:@"CategoryParentName"];
        self.isLeaf = [coder decodeBoolForKey:@"CategoryIsLeaf"];
        //NSLog(@"%@", self.isLeaf ? @"YES" : @"NO");
    }
    return self;
}

- (NSUInteger)hash
{
    return self.id;
}

- (NSString *)description
{
    return [NSString stringWithFormat:@"[Category] id: %d, parentid: %d, name: %@, score: %f, hitcount: %d, is leaf: %@", self.id, self.parentId, self.name, self.score, self.hitCount, isLeaf ? @"YES" : @"NO"];
}

- (BOOL)isEqual:(id)object
{
    if (![object isKindOfClass:[Category class]]) {
        return NO;
    }
    Category *b = object;
    return b.id == self.id;
}

- (void)dealloc {
    [name release];
    [parentName release];
    [super dealloc];
}

@end
