//
//  Product.m
//  Compare Prices
//
//  Created by Jesper Forsberg on 2011-08-13.
//  Copyright 2011 Jesper Forsberg. All rights reserved.
//

#import "Product.h"

@implementation Product

@synthesize id, categoryId, name, info, minPrice, maxPrice, minPrice_c, 
maxPrice_c, storeCount, imageURL, images, stores;

- (void)dealloc {
    NSLog(@"Product: %@ was deallocated!", name);
    [name release];
    [info release];
    [minPrice_c release];
    [maxPrice_c release];
    [imageURL release];
    [images release];
    [stores release];
    [super dealloc];
}

- (void)encodeWithCoder:(NSCoder *)aCoder
{
    [aCoder encodeInteger:self.id forKey:@"product.id"];
    [aCoder encodeInteger:self.categoryId forKey:@"product.categoryId"];
    [aCoder encodeObject:self.name forKey:@"product.name"];
    [aCoder encodeObject:self.info forKey:@"product.info"];
    [aCoder encodeFloat:self.minPrice forKey:@"product.minPrice"];
    [aCoder encodeFloat:self.maxPrice forKey:@"product.maxPrice"];
    [aCoder encodeObject:self.minPrice_c forKey:@"product.minPrice_c"];
    [aCoder encodeObject:self.maxPrice_c forKey:@"product.maxPrice_c"];
    [aCoder encodeInteger:self.storeCount forKey:@"product.storeCount"];
    [aCoder encodeObject:self.imageURL forKey:@"product.imageURL"];
    
    [aCoder encodeObject:self.images forKey:@"product.images"];
    [aCoder encodeObject:self.stores forKey:@"product.stores"];
}

- (id)initWithCoder:(NSCoder *)aDecoder
{
    Product *p = [self init];
    p.id = [aDecoder decodeIntegerForKey:@"product.id"];
    p.categoryId = [aDecoder decodeIntegerForKey:@"product.categoryId"];
    p.name = [aDecoder decodeObjectForKey:@"product.name"];
    p.info = [aDecoder decodeObjectForKey:@"product.info"];
    p.minPrice = [aDecoder decodeFloatForKey:@"product.minPrice"];
    p.maxPrice = [aDecoder decodeFloatForKey:@"product.maxPrice"];
    p.minPrice_c = [aDecoder decodeObjectForKey:@"product.minPrice_c"];
    p.maxPrice_c = [aDecoder decodeObjectForKey:@"product.maxPrice_c"];
    p.storeCount = [aDecoder decodeIntegerForKey:@"product.storeCount"];
    p.imageURL = [aDecoder decodeObjectForKey:@"product.imageURL"];
    
    p.images = [aDecoder decodeObjectForKey:@"product.images"];
    p.stores = [aDecoder decodeObjectForKey:@"product.stores"];
    return p;
}

- (id)init
{
    self = [super init];
    if (self) {
        // Initialization code here.
    }
    
    return self;
}

- (id)copyWithZone:(NSZone *)zone
{
    Product *p = [self init];
    p.id = self.id;
    p.categoryId = self.categoryId;
    p.name = self.name;
    p.info = self.info;
    p.minPrice = self.minPrice;
    p.minPrice_c = self.minPrice_c;
    p.maxPrice = self.maxPrice;
    p.maxPrice_c = self.maxPrice_c;
    p.storeCount = self.storeCount;
    p.imageURL = self.imageURL;
    p.stores = self.stores;
    return p;
}

- (BOOL)isEqual:(id)object
{
    if (![object isKindOfClass:[Product class]]) {
        return NO;
    }
    Product *b = object;
    return b.id == self.id;
}

- (NSUInteger)hash
{
    return self.id;
}

- (NSString *)description
{
    return [NSString stringWithFormat:@"[Product] id: %d, name: %@, storecount: %d, minprice: %f, maxprice: %f",
            self.id, name, storeCount, minPrice, maxPrice];
}


@end
