//
//  ProductImage.m
//  Compare Prices
//
//  Created by Jesper Forsberg on 2011-08-14.
//  Copyright 2011 Jesper Forsberg. All rights reserved.
//

#import "ProductImage.h"

@implementation ProductImage

@synthesize id, microURL, thumbURL, mediumURL, fullURL, width, height;

- (void)dealloc {
    [microURL release];
    [thumbURL release];
    [mediumURL release];
    [fullURL release];
    [super dealloc];
}

- (void)encodeWithCoder:(NSCoder *)aCoder
{
    [aCoder encodeInteger:self.id forKey:@"productimage.id"];
    [aCoder encodeObject:self.microURL forKey:@"productimage.microURL"];
    [aCoder encodeObject:self.thumbURL forKey:@"productimage.thumbURL"];
    [aCoder encodeObject:self.mediumURL forKey:@"productimage.mediumURL"];
    [aCoder encodeObject:self.fullURL forKey:@"productimage.fullURL"];
    [aCoder encodeInteger:self.width forKey:@"productimage.width"];
    [aCoder encodeInteger:self.height forKey:@"productimage.height"];
}

- (id)initWithCoder:(NSCoder *)aDecoder
{
    ProductImage *p = [self init];
    p.id = [aDecoder decodeIntegerForKey:@"productimage.id"];
    p.microURL = [aDecoder decodeObjectForKey:@"productimage.microURL"];
    p.thumbURL = [aDecoder decodeObjectForKey:@"productimage.thumbURL"];
    p.mediumURL = [aDecoder decodeObjectForKey:@"productimage.mediumURL"];
    p.fullURL = [aDecoder decodeObjectForKey:@"productimage.fullURL"];
    p.width = [aDecoder decodeIntegerForKey:@"productimage.width"];
    p.height = [aDecoder decodeIntegerForKey:@"productimage.height"];
    return p;
}

- (id)init
{
    self = [super init];
    if (self) {
        // Initialization code here.
    }
    
    return self;
}

- (NSUInteger)hash
{
    return self.id;
}

- (BOOL)isEqual:(id)object
{
    if (![object isKindOfClass:[ProductImage class]]) {
        return NO;
    }
    
    ProductImage *b = object;
    return b.id == self.id;
}



@end
