//
//  ProductStore.m
//  Compare Prices
//
//  Created by Jesper Forsberg on 2011-08-14.
//  Copyright 2011 Jesper Forsberg. All rights reserved.
//

#import "ProductStore.h"

@implementation ProductStore

@synthesize id, storeId, storeName, storeInfo, price, price_c, show;

- (void)dealloc {
    [storeName release];
    [storeInfo release];
    [price_c release];
    [super dealloc];
}

- (void)encodeWithCoder:(NSCoder *)aCoder
{
    [aCoder encodeInteger:self.id forKey:@"productstore.id"];
    [aCoder encodeInteger:self.storeId forKey:@"productstore.storeId"];
    [aCoder encodeObject:self.storeName forKey:@"productstore.storeName"];
    [aCoder encodeObject:self.storeInfo forKey:@"productstore.storeInfo"];
    [aCoder encodeFloat:self.price forKey:@"productstore.price"];
    [aCoder encodeObject:self.price_c forKey:@"productstore.price_c"];
    [aCoder encodeBool:self.show forKey:@"productstore.show"];
}

- (id)initWithCoder:(NSCoder *)aDecoder
{
    ProductStore *p = [self init];
    p.id = [aDecoder decodeIntegerForKey:@"productstore.id"];
    p.storeId = [aDecoder decodeIntegerForKey:@"productstore.storeId"];
    p.storeInfo = [aDecoder decodeObjectForKey:@"productstore.storeInfo"];
    p.price = [aDecoder decodeFloatForKey:@"productstore.price"];
    p.price_c = [aDecoder decodeObjectForKey:@"productstore.price_c"];
    p.show = [aDecoder decodeBoolForKey:@"productstore.show"];
    return p;
}

- (id)init
{
    self = [super init];
    if (self) {
        // Initialization code here.
    }
    
    return self;
}

- (NSUInteger)hash
{
    return self.id;
}

- (BOOL)isEqual:(id)object
{
    if (![object isKindOfClass:[ProductStore class]]) {
        return NO;
    }
    
    ProductStore *b = object;
    return b.id == self.id;
}


- (NSString *)description
{
    return [NSString stringWithFormat:@"[ProductStore] id: %d, name: %@, price: %f",
            self.id, storeName, price];
}

@end
