//
//  CategoryProductsRequest.h
//  Compare Prices
//
//  Created by Jesper Forsberg on 2011-08-15.
//  Copyright 2011 Jesper Forsberg. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "Request.h"
#import "CategoryProductsResponse.h"

@interface CategoryProductsRequest : NSObject <Request> {
@private
    int categoryId;
    NSString *searchQuery;
    NSString *sort;
    int pageSize;
    float minPrice;
    float maxPrice;
    BOOL showStores;
}

@property (nonatomic, assign) int page;
@property (nonatomic, assign) float minPrice;
@property (nonatomic, assign) float maxPrice;
@property (nonatomic, copy) NSString *sort;
@property (nonatomic, copy) NSString *searchQuery;

- (CategoryProductsResponse *)query:(QuenchClient *)client;

- (void)setCategoryId:(int)v;
- (void)setSort:(NSString *)v;
- (void)setPageSize:(int)v;
- (void)setShowStores:(BOOL)v;

@end
