//
//  ProductRedirectRequest.m
//  Compare Prices
//
//  Created by Jesper Forsberg on 2011-08-15.
//  Copyright 2011 Jesper Forsberg. All rights reserved.
//

#import "ProductRedirectRequest.h"
#import "JSONKit.h"

@implementation ProductRedirectRequest

@synthesize productId, storeId;

- (id)init
{
    self = [super init];
    if (self) {
        // Initialization code here.
    }
    
    return self;
}

- (ProductRedirectResponse *)query:(QuenchClient *)client 
{
    if (!productId) {
        return nil;
    }
    
    if (!storeId) {
        return nil;
    }
    
    NSString *url = [NSString stringWithFormat:@"/product/%d/redirect", productId];
    
    NSDictionary *params = [NSDictionary dictionaryWithObject:[[NSNumber numberWithInt:storeId] stringValue] forKey:@"id"];
    
    id jsonResponse = [[client queryResource:url withParams:params] objectFromJSONData];
    
    if (![jsonResponse isKindOfClass:[NSDictionary class]]) {
        return nil;
    }
    
    ProductRedirectResponse *response = [[ProductRedirectResponse alloc] init];
    
    int trackingId = [[jsonResponse valueForKey:@"trackingid"] intValue];
    response.trackingId = trackingId;
    
    NSURL *redirectURL = [NSURL URLWithString:[jsonResponse valueForKey:@"redirecturl"]];
    response.redirectURL = redirectURL;
    
    return [response autorelease];
}

@end
