//
//  StoreListRequest.m
//  Compare Prices
//
//  Created by Jesper Forsberg on 2011-08-16.
//  Copyright 2011 Jesper Forsberg. All rights reserved.
//

#import "StoreListRequest.h"
#import "JSONKit.h"
#import "Network.h"
#import "Store.h"

@implementation StoreListRequest

- (id)init
{
    self = [super init];
    if (self) {
        // Initialization code here.
        fetchAll = false;
    }
    
    return self;
}

- (void)dealloc {
    
    [super dealloc];
}

- (void)setFetchAll:(BOOL)v
{
    fetchAll = v;
}

- (StoreListResponse *)query:(QuenchClient *)client
{
    StoreListResponse *response = [[StoreListResponse alloc] init];
    
    NSMutableDictionary *params = [NSMutableDictionary dictionary];
    if (fetchAll) {
        [params setObject:@"1" forKey:@"all"];
    }
    
    id jsonResponse = [[client queryResource:@"/store" withParams:[NSDictionary dictionaryWithDictionary:params]] objectFromJSONData];
    
    NSMutableArray *networks = [NSMutableArray array];
    
    id networkDict = [jsonResponse valueForKey:@"networks"];
    for (id networkKey in networkDict) {
        Network *network = [[Network alloc] init];
        id networkObj = [networkDict valueForKey:networkKey];
        
        network.id = [[networkObj valueForKey:@"id"] intValue];
        network.name = [networkObj valueForKey:@"name"];
        
        id networkDataObj = [networkObj valueForKey:@"data"];
        id networkDataKeys = [networkDataObj allKeys];
        for (id networkDataKey in networkDataKeys) {
            NSString *dataKey = networkDataKey;
            NSString *dataValue = [networkDataObj valueForKey:dataKey];
            [network addDispatchDataObject:dataValue withKey:dataKey];
        }
        
        [networks addObject:network];
        [network release];
    }
    [response setNetworks:[NSArray arrayWithArray:networks]];
    
    NSMutableArray *stores = [NSMutableArray array];
    for (id storeObj in [jsonResponse valueForKey:@"stores"]) {
        Store *store = [[Store alloc] init];
        store.id = [[storeObj valueForKey:@"id"] intValue];
        store.networkId = [[storeObj valueForKey:@"networkid"] intValue];
        store.name = [storeObj valueForKey:@"name"];
        store.active = [[storeObj valueForKey:@"active"] boolValue];
        [stores addObject:store];
        [store release];
    }
    [response setStores:stores];
    return [response autorelease];
}

@end
