//
//  StoreUpdateRequest.m
//  Compare Prices
//
//  Created by Jesper Forsberg on 2011-08-16.
//  Copyright 2011 Jesper Forsberg. All rights reserved.
//

#import "StoreUpdateRequest.h"
#import "JSONKit.h"

@implementation StoreUpdateRequest 

- (id)init
{
    self = [super init];
    if (self) {
        // Initialization code here.
        [self setSiteIds:[NSDictionary dictionary]];
        [self setActiveStores:[NSArray array]];
    }
    
    return self;
}

- (void)setSiteIds:(NSDictionary *)v
{
    if (v != siteIds) {
        [siteIds release];
        siteIds = [v copy];
    }
}

- (void)setActiveStores:(NSArray *)v
{
    if (v != activeStores) {
        [activeStores release];
        activeStores = [v copy];
    }
}

- (StoreListResponse *)query:(QuenchClient *)client
{
    NSString *url = @"/store";
    
    NSMutableDictionary *data = [NSMutableDictionary dictionary];
    for (id key in siteIds) {
        int networkId = [key intValue];
        NSString *siteId = [siteIds valueForKey:key];
        [data setValue:siteId forKey:[NSString stringWithFormat:@"siteid[%d]", networkId]];
    }
    
    NSMutableString *activeStoreList = [NSMutableString string];
    NSString *delim = @"";
    for (id storeId in activeStores) {
        [activeStoreList appendString:delim];
        [activeStoreList appendString:storeId];
        delim = @",";
    }
    
    [data setValue:[NSString stringWithString:activeStoreList] forKey:@"activestores"];
    
    NSDictionary *params = [NSDictionary dictionary];
    id jsonResponse = [[client queryResource:url withParams:params byMethod:@"POST" withData:data] objectFromJSONData];
    NSLog(@"%@", jsonResponse);
    return nil;
}

@end
